HDU - 1069 Monkey and Banana (最长递增子序列的变形)

                                           Monkey and Banana

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 24208    Accepted Submission(s): 12975

Problem Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.
The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. 
They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. 
Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".

Sample Input

1 10 20 30 2 6 8 10 5 5 5 7 1 1 1 2 2 2 3 3 3 4 4 4 5 5 5 6 6 6 7 7 7 5 31 41 59 26 53 58 97 93 23 84 62 64 33 83 27 0

Sample Output

Case 1: maximum height = 40

Case 2: maximum height = 21

Case 3: maximum height = 28

Case 4: maximum height = 342


题意 : 给出 N 种长方体,每种长方体数量不限,要求用这些长方体摞起来的最大高度。只有 A 长方体的底面的长和宽 严格小于 B 长方体的顶面的长和宽,A 长方体才能放在 B 长方体的上面。( 顶面和底面是一样的 )

思路 : 每个长方体(用 (x,y, z)表示)的顶面都最多有三种情况 (x,y)、(y,z)、(x,z)。所以每种长方体各取三个,N的最大值为30,因此最多90种顶面不相同的情况。然后只要将这顶面的不同的长方体,根据长和宽进行排序,此时的情况就有点类似 (HDU - 1087 Super Jumping! Jumping! Jumping! 最长上升子序列和)的例题,只是一个是数值严格大于,另一个是长和宽严格大于,复杂度为 O(n ^ 2)。dp[ i ] 表示以 i 长方体为最 顶端长方体 时所能摞起来的最大高度。具体细节看代码

//#include <bits/stdc++.h>
#include <map>
//#include <tr1/unordered_map>
#include<limits>
#include <float.h>
#include <list>
#include <set>
#include <ctime>
#include <cmath>
#include <queue>
#include <stack>
#include <vector>
#include <string>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <sstream>
#include <iostream>
#include <algorithm>
#include <functional>
using namespace std;
inline int lowbit(int x){ return x & (-x); }
inline int read(){int X = 0, w = 0; char ch = 0;while(!isdigit(ch)) { w |= ch == '-'; ch = getchar(); }
    while(isdigit(ch)) X = (X << 3) + (X << 1) + (ch ^ 48), ch = getchar();return w ? -X : X;}
inline int gcd(int a, int b){ return b ? gcd(b, a % b) : a; }
inline int lcm(int a, int b){ return a / gcd(a, b) * b; }
#define For(i, x, y) for(int i=x;i<=y;i++)
#define _For(i, x, y) for(int i=x;i>=y;i--)
#define Mem(f, x) memset(f,x,sizeof(f))
#define Sca(x) scanf("%d", &x)
#define Sca2(x,y) scanf("%d%d",&x,&y)
#define Sca3(x,y,z) scanf("%d%d%d",&x,&y,&z)
#define Scl(x) scanf("%lld",&x)
#define Pri(x) printf("%d\n", x)
#define Prl(x) printf("%lld\n",x)
#define CLR(u) for(int i=0;i<=N;i++)u[i].clear();
#define db double
#define LL long long
#define ULL unsigned long long
#define mp make_pair
#define PII pair<int,int>
#define PIL pair<int,long long>
#define PLL pair<long long,long long>
#define pb push_back
#define fi first
#define se second
typedef vector<int> VI;
const double pi = acos(-1.0);
const double eps = 1e-8;
const int maxn = 1e6 + 10;
const int maxp = 1e3 + 10;
const LL INF = 0x3f3f3f3f;
const int inf = 0x3f3f3f3f;
const int mod = 20090717;

int n, cnt, a, b, c, ans;
int dp[100];

struct node
{
    int x; //长
    int y; //宽
    int z; //高
    node(int x = 0, int y = 0, int z = 0): x(x), y(y), z(z){};
    bool operator < (const node& rhs) const{
        if (x == rhs.x) return y > rhs.y;
        return x > rhs.x;
    }
}arr[100];

int main()
{
    int kase = 1;
    while (~scanf("%d", &n) && n){
        cnt = 0; ans = -inf;
        Mem(dp, 0);
        For (i, 1, n){
            Sca3(a, b, c);
            arr[++cnt] = node(max(a, b), min(a, b), c); // max(a, b) 保证 x 是长,min(a, b)保证 y 是宽
            arr[++cnt] = node(max(a, c), min(a, c), b);
            arr[++cnt] = node(max(c, b), min(c, b), a);
        }
        sort(arr + 1, arr + 1 + cnt); //‘长’越大的在前,‘长’相等,‘宽’越大的在前
        For (i, 1, cnt){ //初始化
            dp[i] = arr[i].z;
            ans = max(ans, dp[i]);
        }
        For (i, 2, cnt)
        For (j, 1, i - 1){
            if (arr[i].x < arr[j].x && arr[i].y < arr[j].y){ // i 立方体的底面要严格小于 j 立方体的顶面
                dp[i] = max(dp[i], dp[j] + arr[i].z);
                ans = max(ans, dp[i]);
            }
        }
        printf("Case %d: maximum height = %d\n", kase++, ans);
    }

    return 0;
}

 

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值